#include <stdio.h>
#include <stdlib.h>
#include <time.h>

const int TEST = 0;

const int MAXN = 10000;
const int MAXP = MAXN * MAXN;

typedef struct {
   int x;
   int v;
} Djak;


typedef struct {
   int dx;
   int dv;
   int i;
   int j;
} Presek;

Djak djaci[MAXN];
Presek preseci[MAXP];
int poz[MAXN];
int koji[MAXN];



inline double abs (double a)
{
 return a>=0?a:-a;
}
inline double min(double a, double b) {
 return a<b?a:b;
}
inline int min(int a, int b) {
 return a<b?a:b;
}
inline int max(int a, int b) {
 return a>b?a:b;
}

int presek(Djak* a, int i, int j, Presek& p) {
     p.dx = a[i].x - a[j].x;
     p.dv = a[j].v - a[i].v;
     p.i = i;
     p.j = j;
     return p.dx * p.dv > 0;
}

int op(const void * a, const void * b) {
    Djak* pa = (Djak *)a;
    Djak* pb = (Djak *)b;
    if (pa->x != pb->x)
       return (pa->x) - (pb->x);
    return (pa->v) - (pb->v);
}

int cmpPresek(const void * a, const void * b) {
    Presek* pa = (Presek *)a;
    Presek* pb = (Presek *)b;
    int v =  pa->dx * pb->dv - pb->dx * pa->dv;
    if (v!=0)
       return v;
    
    int r = djaci[pa->i].x - djaci[pb->i].x;
    if (r!=0) return r;
    r = djaci[pa->j].x - djaci[pb->j].x;
    if (r!=0) return r;
    r = pa->i - pb->i;    
    if (r!=0) return r;
    r = pa->j - pb->j;
    return r;
}

void razmeni(int* poz, int* koji, int i, int j)
{
     koji[poz[i]]=j;
     koji[poz[j]]=i;
     int pom = poz[i];
     poz[i] = poz[j];
     poz[j] = pom;     
}

double vreme(Presek& p) {
       return 1.0*p.dx/p.dv;
}

double pozicija(Djak& a, double t) {
       return (t*a.v+a.x);     
}

double rastojanje(Djak* a, int i, int j, Presek& p) {
       double t= vreme(p);
       return abs(pozicija(a[i],t)-pozicija(a[j],t));
}



double calc(int n, int k, Djak* a) {
    qsort(a, n, sizeof(Djak), op);

    int broj = 0;
    int i,j;
    double res = 1e50;
    for (i=0;i<n;i++) {
        if (i+k-1 < n)
           res = min(res, (double)abs(a[i].x - a[i+k-1].x));
        if (TEST)
           printf("%d %d\n", a[i].x, a[i].v);
        if (i+1<n) 
           if (a[i].x==a[i+1].x && a[i].v==a[i+1].v)
              printf("imamo istih %d %d\n", a[i].x, a[i].v);
        poz[i] = i;
        koji[i] = i;
    }
    if (TEST)
       printf("\n");

    for (i = 0;i<n;i++) 
        for(j = i+1;j<n;j++)
        {
            if (presek(a, i, j, preseci[broj])>0)
               broj++;
        }
    int start = clock();
  
    qsort(preseci, broj, sizeof(Presek), cmpPresek);
      
     
    printf("sortiranje %d %d\n", broj, clock()-start);  
      
   
    int p;
    for (p = 0;p<broj;p++) {
        i = preseci[p].i;
        j = preseci[p].j;
        int c;
        if (TEST) {
           for (c=0;c<n;c++) 
               printf("%d  ", koji[c]);
           printf("\n");
           printf("%d %d\t%d %d\n", i, j, poz[i], poz[j]);
        }

        if (koji[poz[i]]!=i || koji[poz[j]]!=j)
           printf("GREEESKA %d %d\n", poz[i], poz[j]);

        if (abs(poz[i]-poz[j])>1) {
           printf("BAAAD %d %d\n", poz[i], poz[j]);
        }
        razmeni(poz, koji, i, j);
        int left = min(poz[i], poz[j]);
        int right = left + k-1;
        double r ;
        if (right <n)
        {
           r = rastojanje(a, koji[left], koji[right], preseci[p]);        
           if (TEST) 
              printf("\t%d %d %lf\n", left , right, r);
           res = min(res, r); 
        }
        right = max(poz[i], poz[j]);
        left = right - k+1;
        if (left>=0)
        {
           r =  rastojanje(a, koji[left], koji[right], preseci[p]);        
           if (TEST)
              printf("\t%d %d %lf\n", left , right, r);
           res = min(res, r); 
        }
    }    
    return res/2;
}




long long slucajni() {
     return (((long long)rand()*1007+rand())*1007+rand())/991;
}

int main() {
    int index1 = 9;
    char filein[18] = "klizanje.xx.in";
    char fileout[18] = "klizanje.xx.sol";
    FILE* fin;
    FILE*  fout;
    srand(20);
    int T = 10;
    int n[11] =      {5,   5,   10,   20,   100  ,200,  200,500,1000,1000,1000};
    int k[11] =      {3,   1,   4,    5,    10   ,150,  100,3,100,500,900};
    int maxx[11] =   {50,  50,  100,  1000, 1000 ,300,  500000,500000,500000,10000,500000};
    int maxv[11] =   {20,  20,  50,   51,   201  ,501,  1001,2001,101,2001,2001};
    int i,j;
    for (i = 0;i<=T;i++) 
    {
        filein[index1] = (i/10)+'0';
        filein[index1+1] = (i%10)+'0';
        
        fileout[index1] = (i/10)+'0';
        fileout[index1+1] = (i%10)+'0';
        
        
        fin = fopen(filein, "w");
        fout = fopen(fileout, "w");
        
        
        for(j = 0;j<n[i];j++)
        {
            djaci[j].x =(int) (slucajni() ^ slucajni())% maxx[i];  //
            djaci[j].v =(int) (slucajni() ^ slucajni()) % maxv[i] - maxv[i]/2;   
        }
        
           
        fprintf(fin, "%d %d\n", n[i], k[i]);
        for (j = 0;j<n[i];j++)
           fprintf(fin, "%d %d\n", djaci[j].x, djaci[j].v);
        
        int start = clock();
        
        double res = calc(n[i], k[i], djaci);
        fprintf(fout, "%lf\n", res);
           
        printf("%d %d\t\t%lf\n", n[i], clock()-start, res);   
           
        fclose(fin);
        fclose(fout);
    }
    
    system("pause");
    return 0;   
}
